# rpmbuild --rebuild --with testsuite --without clustering samba.src.rpm
#
# The testsuite is disabled by default. Set --with testsuite or bcond_without
# to run the Samba torture testsuite.
%bcond_with testsuite
# ctdb is enabled by default, you can disable it with: --without clustering
%bcond_without clustering

%define _disable_ld_no_undefined %{nil}
%global __brp_check_rpaths %nil

%define nssmajor 2

%define major 1
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d

%define wbclientmajor 0
%define libwbclient %mklibname wbclient %{wbclientmajor}
%define wbclientdevel %mklibname wbclient -d

%define smbclientmajor 0
%define libsmbclient %mklibname smbclient %{smbclientmajor}
%define smbclientdevel %mklibname smbclient -d

%define testmajor 0
%define libtest %mklibname %{name}-test %{testmajor}
%define testdevel %mklibname %{name}-test -d

%define dcmajor 0
%define libsdc %mklibname %{name}-dc %{dcmajor}

%define kdcmajor 2
%define libkdc %mklibname kdc-samba4_ %{kdcmajor}

%define heimntlmmajor 1
%define libheimntlm %mklibname heimntlm-samba4_ %{heimntlmmajor}

# filter out some bogues devel() requires
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}devel\\(lib.*-samba4

# filter out some bogus requires/provides
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libdir}/libnss_win.*\\.so
%global __requires_exclude_from %{?__requires_exclude_from:%__requires_exclude_from|}^%{_libdir}/libnss_win.*\\.so

# more filtering
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}lib.*samba4.so\\(
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}lib.*samba4.so\\(

# filter out perl requirements pulled in from examples in the docdir.
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_docdir}
%global __requires_exclude_from %{?__requires_exclude_from:%__requires_exclude_from|}^%{_docdir}/\[^/\]*/\[^M\]
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(VMS|^perl\\(Win32|^perl\\(DB\\)|^perl\\(UNIVERSAL\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(VMS|^perl\\(Win32

%global cups_serverbin /usr/lib/cups

%define rel 1

%define talloc_version 2.3.3
%define ntdb_version 1.0
%define tdb_version 1.4.6
%define tevent_version 0.11.0
%define ldb_version 2.5.2
# This should be rc1 or %%nil
%define pre_release %nil

%if "x%{?pre_release}" != "x"
%define tardir rc
%define samba_release 0.%{pre_release}.%{rel}
%else
%define tardir stable
%define samba_release %{rel}
%endif

%global with_libsmbclient 1
%global with_libwbclient 1

%global with_internal_talloc 0
%global with_internal_tevent 0
%global with_internal_tdb 0
%global with_internal_ntdb 0
%global with_internal_ldb 0

%global with_profiling 1

%global with_vfs_cephfs 0

%global with_vfs_glusterfs 0


%global with_mitkrb5 0
%global with_dc 1

%if %{with testsuite}
# The testsuite only works with a full build right now.
%global with_mitkrb5 0
%global with_dc 1
%endif

%global with_clustering_support 0

%if %{with clustering}
%global with_clustering_support 1
%endif

Name:       samba
Version:    4.16.4
Release:    %mkrel 1

Summary:    Server and Client software to interoperate with Windows machines
License:    GPLv3+ and LGPLv3+
Group:      System/Servers
URL:        http://www.samba.org/
Source0:    https://download.samba.org/pub/samba/%{tardir}/samba-%{version}.tar.xz

# Red Hat specific replacement-files
Source1: samba.log
Source2: samba.xinetd
Source4: smb.conf.default
Source5: pam_winbind.conf
Source6: samba.pamd

Source200: README.dc
Source201: README.downgrade

#services
Source300: winbind.init
Source301: smb.init
Source302: nmb.init
Source303: samba.init

Requires(pre):    rpm-helper
Requires(post):   rpm-helper 
Requires(preun):  rpm-helper
Requires(postun): rpm-helper

BuildRequires: cups-devel
BuildRequires: pkgconfig(dbus-1)
BuildRequires: docbook-style-xsl
BuildRequires: e2fsprogs-devel
BuildRequires: gawk
BuildRequires: krb5-devel >= 1.10
BuildRequires: libacl-devel
BuildRequires: libaio-devel
BuildRequires: pkgconfig(libarchive)
BuildRequires: pkgconfig(libattr)
BuildRequires: pkgconfig(libcap)
BuildRequires: pkgconfig(uuid)
BuildRequires: pkgconfig(libxslt)
BuildRequires: lmdb-devel
BuildRequires: pkgconfig(ncurses)
BuildRequires: openldap-devel
BuildRequires: pam-devel
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(Parse::Yapp)
BuildRequires: pkgconfig(popt)
BuildRequires: pkgconfig(python3)
BuildRequires: python3-tevent
BuildRequires: quota-devel
BuildRequires: readline-devel
BuildRequires: sed
BuildRequires: pkgconfig(zlib)
BuildRequires: xsltproc
BuildRequires: libgpgme-devel
BuildRequires: pkgconfig(cmocka)
BuildRequires: pkgconfig(jansson)
BuildRequires: rpcgen

%if %{with_vfs_glusterfs}
BuildRequires: 	pkgconfig(glusterfs-api)
%endif
%if %{with_vfs_cephfs}
BuildRequires: libcephfs1-devel
%endif
%if %{with_dc}
BuildRequires: pkgconfig(gnutls)
%endif

# pidl requirements
BuildRequires: perl(Parse::Yapp)

%if ! %{with_internal_talloc}
BuildRequires: 	pkgconfig(talloc) >= %{talloc_version}
BuildRequires: 	pytalloc-util-devel >= %{talloc_version}
BuildRequires: 	python3-talloc >= %{talloc_version}
%endif

%if ! %{with_internal_tevent}
BuildRequires: 	pkgconfig(tevent) >= %{tevent_version}
BuildRequires: 	python3-tevent >= %{tevent_version}
%endif

%if ! %{with_internal_ldb}
BuildRequires: 	pkgconfig(ldb) >= %ldb_version
BuildRequires: 	pyldb-util-devel >= %{ldb_version}
BuildRequires:  python3-ldb >= %{ldb_version}
%endif

%if ! %{with_internal_tdb}
BuildRequires: 	pkgconfig(tdb) >= %{tdb_version}
BuildRequires:  python3-tdb >= %{tdb_version}
%endif

%if %{with testsuite}
BuildRequires: 	ldb-tools
%endif

### SAMBA
%description
Samba is the standard Windows interoperability suite of programs
for Linux and Unix.


%package server
URL:	http://www.samba.org
Summary: Samba (SMB) server programs
Requires(pre):		rpm-helper
Group: Networking/Other

Requires(pre):	%{name}-common = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}
%if %{with_libwbclient}
Requires: 	%{libwbclient} = %{version}-%{release}
%endif

Requires: pam
Requires: start-stop-daemon
Obsoletes: samba-doc
Obsoletes: samba-domainjoin-gui
Obsoletes: samba-swat

Obsoletes: samba
Provides: samba = %{version}-%{release}

%description server
Samba is the standard Windows interoperability suite of programs
for Linux and Unix.


### CLIENT
%package client
Summary: 	Samba client programs
Group: 		Networking/Other
Requires: 	%{name}-common = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}
%if %{with_libsmbclient}
Requires: 	%{libsmbclient} = %{version}-%{release}
%endif
# virtual provides for drakxtools-backend
Provides:	smb-client = %{version}-%{release}

Requires(post):   chkconfig
Requires(postun): chkconfig

%description client
The samba4-client package provides some SMB/CIFS clients to complement
the built-in SMB/CIFS filesystem in Linux. These clients allow access
of SMB/CIFS shares and printing to SMB/CIFS printers.

### COMMON
%package common
Summary: Files used by both Samba servers and clients
Group: 		System/Servers
Requires: 	%{libname} = %{version}-%{release}
Requires:	%{libsdc} = %{version}-%{release}
%if %{with_libwbclient}
Requires: 	%{libwbclient} = %{version}-%{release}
%endif

%description common
samba-common provides files necessary for both the server and client
packages of Samba.

### DC
%package dc
Summary: 	Samba AD Domain Controller
Group: 		System/Servers
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{libsdc} = %{version}-%{release}
Requires: 	python3-samba = %{version}-%{release}

%description dc
The samba-dc package provides AD Domain Controller functionality

### DC-LIBS
%package -n %{libsdc}
Summary: 	Samba AD Domain Controller Libraries
Group: 		System/Servers
Requires: 	%{name}-common = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}


%description -n %{libsdc}
The samba4-dc-libs package contains the libraries needed by the DC to
link against the SMB, RPC and other protocols.

%if %{with_dc}
%package -n %{libkdc}
Summary:	Samba AD Domain Controller KDC Libraries
Group:		System/Libraries


%description -n %{libkdc}
This package contains Kerberos KDC libraries for Samba.

%package -n %{libheimntlm}
Summary:	Samba AD Domain controller NTLM Libraries
Group:		System/Libraries


%description -n %{libheimntlm}
This package contains NTLM libraries for Samba.
%endif

### DEVEL
%package -n %{develname}
Summary: 	Developer tools for Samba libraries
Group: 		Development/Libraries
Requires: 	%{libname} = %{version}-%{release}
Provides:	libsamba-devel = %{version}-%{release}
Provides:	samba-devel = %{version}-%{release}
AutoReq:	false
Obsoletes: lib64netapi-devel
Obsoletes: lib64smbsharemodes-devel

%description -n %{develname}
The samba4-devel package contains the header files for the libraries
needed to develop programs that link against the SMB, RPC and other
libraries in the Samba suite.

### CEPH
%if %{with_vfs_cephfs}
%package vfs-cephfs
Summary: Samba VFS module for Ceph distributed storage system
Group: Applications/System
Requires: libcephfs1
Requires: samba-server = %{version}-%{release}
Requires: %{libname} = %{version}-%{release}

%description vfs-cephfs
Samba VFS module for Ceph distributed storage system integration.
%endif

### GLUSTER
%if %{with_vfs_glusterfs}
%package vfs-glusterfs
Summary: 	Samba VFS module for GlusterFS
Group: 		System/Libraries
Requires: 	glusterfs-api >= 3.4.0.16
Requires: 	glusterfs >= 3.4.0.16
Requires: 	samba-server = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}


%description vfs-glusterfs
Samba VFS module for GlusterFS integration.
%endif

### KRB5-PRINTING
%package krb5-printing
Summary: Samba CUPS backend for printing with Kerberos
Group: Networking/Remote access
Requires(pre): %{name}-client

Requires(post):   chkconfig
Requires(postun): chkconfig

%description krb5-printing
If you need Kerberos for print jobs to a printer connection to cups via the SMB
backend, then you need to install that package. It will allow cups to access
the Kerberos credentials cache of the user issuing the print job.

### LIBS
%package -n %{libname}
Summary: 	Samba libraries
Group: 		System/Libraries
Requires: 	krb5-libs >= 1.10
Obsoletes: lib64smbsharemodes0
Obsoletes: lib64netapi0

%if %{with_libwbclient}
Requires: 	%{libwbclient} = %{version}-%{release}
%endif

%description -n %{libname}
The samba4-libs package contains the libraries needed by programs that
link against the SMB, RPC and other protocols provided by the Samba suite.

### LIBSMBCLIENT
%if %{with_libsmbclient}
%package -n %{libsmbclient}
Summary: 	The SMB client library
Group: 		System/Libraries
Requires: 	%{name}-common = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}
Provides:       libsmbclient = %{version}-%{release}

%description -n %{libsmbclient}
The libsmbclient contains the SMB client library from the Samba suite.

%package -n %{smbclientdevel}
Summary: 	Developer tools for the SMB client library
Group: 		Development/Libraries
Requires: 	%{libsmbclient} = %{version}-%{release}
Provides:	libsmbclient-devel = %{version}-%{release}
Provides:	smbclient-devel = %{version}-%{release}
Obsoletes:  lib64smbclient0-devel
Provides:   lib64smbclient0-devel = %{version}-%{release}
Obsoletes:  lib64smbclient0-static-devel
Provides:   lib64smbclient0-static-devel = %{version}-%{release}
AutoReq:	false

%description -n %{smbclientdevel}
The libsmbclient-devel package contains the header files and libraries needed to
develop programs that link against the SMB client library in the Samba suite.
%endif # with_libsmbclient

### LIBWBCLIENT
%if %{with_libwbclient}
%package -n %{libwbclient}
Summary: 	The winbind client library
Group: 		System/Libraries
Requires: 	%{libname} = %{version}-%{release}

%description -n %{libwbclient}
The libwbclient package contains the winbind client library
from the Samba suite.

%package -n %{wbclientdevel}
Summary: 	Developer tools for the winbind library
Group: 		Development/Libraries
Requires: 	%{libwbclient} = %{version}-%{release}
Provides:	libwbclient-devel = %{version}-%{release}
Provides:	wbclient-devel = %{version}-%{release}
AutoReq:	false

%description -n %{wbclientdevel}
The libwbclient-devel package provides developer tools for
the wbclient library.
%endif # with_libwbclient

%package -n python3-samba
Summary: 	Samba Python libraries
Group: 		System/Libraries
Requires: 	samba-server = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}
Requires: 	python3-tevent
Requires: 	python3-tdb
Requires: 	python3-ldb
Requires: 	python3-talloc

%description -n python3-samba
The samba4-python package contains the Python libraries needed by programs
that use SMB, RPC and other Samba provided protocols in Python programs.

### PIDL
%package pidl
Summary: 	Perl IDL compiler
Group: 		Development/Tools
Requires: 	perl(Parse::Yapp)
BuildArch: 	noarch


%description pidl
The %{name}-pidl package contains the Perl IDL compiler used by Samba
and Wireshark to parse IDL and similar protocols

### TEST
%package test
Summary: 	Testing tools for Samba servers and clients
Group: 		Networking/Other
Requires: 	samba-server = %{version}-%{release}
Requires: 	%{name}-common = %{version}-%{release}
Requires: 	%{name}-winbind = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}

%if %{with_dc}
Requires: 	%{libsdc} = %{version}-%{release}
%endif

%if %{with_libsmbclient}
Requires: 	%{libsmbclient} = %{version}-%{release}
%endif

%if %{with_libwbclient}
Requires: 	%{libwbclient} = %{version}-%{release}
%endif

%description test
%{name}-test provides testing tools for both the server and client
packages of Samba.

### TEST-LIBS
%package -n %{libtest}
Summary: 	Libraries need by teh testing tools for Samba servers and clients
Group: 		Networking/Remote access
Requires: 	%{libname} = %{version}-%{release}


%description -n %{libtest}
%{name}-test-libs provides libraries required by the testing tools.

### TEST-DEVEL
%package -n %{testdevel}
Summary: 	Testing devel files for Samba servers and clients
Group: 		Development/Libraries
Requires: 	%{libtest} = %{version}-%{release}


%description -n %{testdevel}
samba-test-devel provides testing devel files for both the server and client
packages of Samba.

### WINBIND
%package winbind
Summary: 	Samba winbind
Group: 		System/Libraries
Requires: 	%{name}-common = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{name}-winbind-modules = %{version}-%{release}
Obsoletes:	nss_wins < 4.0.0
Provides:	nss_wins = %{version}-%{release}

%description winbind
The samba-winbind package provides the winbind NSS library, and some
client tools.  Winbind enables Linux to be a full member in Windows
domains and to use Windows user and group accounts on Linux.

### WINBIND-CLIENTS
%package winbind-clients
Summary: 	Samba winbind clients
Group: 		System/Libraries
Requires: 	%{name}-common = %{version}-%{release}
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{name}-winbind = %{version}-%{release}
%if %{with_libwbclient}
Requires: 	%{libwbclient} = %{version}-%{release}
%endif

Provides: samba4-winbind-clients = %{version}-%{release}

%description winbind-clients
The samba-winbind-clients package provides the wbinfo and ntlm_auth
tool.

### WINBIND-KRB5-LOCATOR
%package winbind-krb5-locator
Summary: 	Samba winbind krb5 locator
Group: 		Networking/Remote access
%if %{with_libwbclient}
Requires: 	%{libwbclient} = %{version}-%{release}
Requires: 	%{name}-winbind = %{version}-%{release}
%else
Requires: 	%{libname} = %{version}-%{release}
%endif
Provides: 	samba4-winbind-krb5-locator = %{version}-%{release}

Requires(post):   chkconfig
Requires(postun): chkconfig
Requires(preun):  chkconfig

%description winbind-krb5-locator
The winbind krb5 locator is a plugin for the system kerberos library to allow
the local kerberos library to use the same KDC as samba and winbind use

### WINBIND-MODULES
%package winbind-modules
Summary: 	Samba winbind modules
Group: 		System/Libraries
Requires: 	%{libname} = %{version}-%{release}
%if %{with_libwbclient}
Requires: 	%{libwbclient} = %{version}-%{release}
%endif
Requires: 	pam
AutoReq:	false

%description winbind-modules
The samba-winbind-modules package provides the NSS library and a PAM
module necessary to communicate to the Winbind Daemon

### CTDB
%if %{with_clustering_support}
%package -n ctdb
Summary: A Clustered Database based on Samba's Trivial Database (TDB)
Group: System/Cluster

Requires: coreutils
#Requires: fileutils
# for ps and killall
Requires: psmisc
Requires: sed
Requires: tdb-utils
Requires: gawk
# for pkill and pidof:
Requires: procps
# for netstat:
Requires: net-tools
Requires: ethtool
# for ip:
Requires: iproute2
Requires: iptables
# for flock, getopt, kill:
Requires: util-linux


%description -n ctdb
CTDB is a cluster implementation of the TDB database used by Samba and other
projects to store temporary data. If an application is already using TDB for
temporary data it is very easy to convert that application to be cluster aware
and use CTDB instead.

### CTDB-DEVEL
%package -n ctdb-devel
Summary: CTDB clustered database development package
Group: Development/Other

Requires: ctdb = %{version}-%{release}

%description -n ctdb-devel
Libraries, include files, etc you can use to develop CTDB applications.
CTDB is a cluster implementation of the TDB database used by Samba and other
projects to store temporary data. If an application is already using TDB for
temporary data it is very easy to convert that application to be cluster aware
and use CTDB instead.

### CTDB-TEST
%package -n ctdb-tests
Summary: CTDB clustered database test suite
Group: Development/Other

Requires: ctdb = %{version}-%{release}
Requires: nmap

%description -n ctdb-tests
Test suite for CTDB.
CTDB is a cluster implementation of the TDB database used by Samba and other
projects to store temporary data. If an application is already using TDB for
temporary data it is very easy to convert that application to be cluster aware
and use CTDB instead.
%endif # with_clustering_support

%prep
%setup -qn samba-%{version}

%build
%serverbuild

%global _talloc_lib ,talloc,pytalloc,pytalloc-util
%global _tevent_lib ,tevent,pytevent
%global _tdb_lib ,tdb,pytdb
%global _ldb_lib ,ldb,pyldb,pyldb-util

%if ! %{with_internal_talloc}
%global _talloc_lib ,!talloc,!pytalloc,!pytalloc-util
%endif

%if ! %{with_internal_tevent}
%global _tevent_lib ,!tevent,!pytevent
%endif

%if ! %{with_internal_tdb}
%global _tdb_lib ,!tdb,!pytdb
%endif

%if ! %{with_internal_ldb}
%global _ldb_lib ,!ldb,!pyldb
%endif

%global _samba_libraries heimdal,!zlib,!popt%{_talloc_lib}%{_tevent_lib}%{_tdb_lib}%{_ldb_lib}

%global _samba4_idmap_modules idmap_ad,idmap_rid,idmap_adex,idmap_hash,idmap_tdb2
%global _samba4_pdb_modules pdb_tdbsam,pdb_ldap,pdb_ads,pdb_smbpasswd,pdb_wbc_sam,pdb_samba4
%global _samba4_auth_modules auth_unix,auth_wbc,auth_server,auth_netlogond,auth_script,auth_samba4

%global _samba_modules %{_samba4_idmap_modules},%{_samba4_pdb_modules},%{_samba4_auth_modules}

%global _libsmbclient %nil
%global _libwbclient %nil

%if ! %{with_libsmbclient}
%global _libsmbclient smbclient,
%endif

%if ! %{with_libwbclient}
%global _libwbclient wbclient,
%endif

%global _samba_private_libraries %{_libsmbclient}%{_libwbclient}

# TODO: resolve underlinked python modules
export python_LDFLAGS="$(echo %{__global_ldflags} | sed -e 's/-Wl,-z,defs//g')"

%configure2_5x \
        --enable-fhs \
        --sysconfdir=%{_sysconfdir} \
        --prefix=%{_prefix} \
        --localstatedir=%{_localstatedir} \
        --with-piddir=/var/run \
        --with-sockets-dir=/var/run/samba \
        --with-modulesdir=%{_libdir}/samba \
        --with-pammodulesdir=%{_libdir}/security \
        --with-lockdir=/var/lib/samba/lock \
        --with-cachedir=/var/lib/samba \
        --disable-rpath-install \
        --with-shared-modules=%{_samba_modules} \
        --bundled-libraries=%{_samba_libraries} \
        --with-pam \
        --with-pie \
        --with-relro \
        --without-fam \
        --without-systemd \
%if (! %{with_libsmbclient}) || (! %{with_libwbclient})
        --private-libraries=%{_samba_private_libraries} \
%endif
%if %{with_mitkrb5}
        --with-system-mitkrb5 \
%if %{with_dc}
        --with-experimental-mit-ad-dc \
%endif
%endif
%if ! %{with_dc}
        --without-ad-dc \
%endif
%if ! %{with_vfs_glusterfs}
        --disable-glusterfs \
%endif
%if %{with_clustering_support}
        --with-cluster-support \
%endif
%if %{with_profiling}
        --with-profiling-data \
%endif
%if %{with testsuite}
        --enable-selftest \
%endif

%make_build

%install
rm -rf %buildroot
%make_install

install -d -m 0755 %{buildroot}/usr/{sbin,bin}
install -d -m 0755 %{buildroot}%{_libdir}/security
install -d -m 0755 %{buildroot}/var/lib/samba
install -d -m 0755 %{buildroot}/var/lib/samba/lock
install -d -m 0755 %{buildroot}/var/lib/samba/private
install -d -m 0755 %{buildroot}/var/lib/samba/winbindd_privileged
install -d -m 0755 %{buildroot}/var/lib/samba/scripts
install -d -m 0755 %{buildroot}/var/lib/samba/sysvol
install -d -m 0755 %{buildroot}/var/log/samba/old
install -d -m 0755 %{buildroot}/var/spool/samba
install -d -m 0755 %{buildroot}/var/run/samba
install -d -m 0755 %{buildroot}/run/winbindd
install -d -m 0755 %{buildroot}/%{_libdir}/samba
install -d -m 0755 %{buildroot}/%{_libdir}/samba/ldb
install -d -m 0755 %{buildroot}/%{_libdir}/pkgconfig
install -d -m 0755 %{buildroot}/%{_initrddir}

# Move smbspool_krb5_wrapper
#install -d -m 0755 %{buildroot}%{_libexecdir}/samba
#mv %{buildroot}%{_bindir}/smbspool_krb5_wrapper %{buildroot}%{_libexecdir}/samba

# Install other stuff
install -d -m 0755 %{buildroot}%{_sysconfdir}/logrotate.d
install -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/samba

install -m 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/samba/smb.conf

install -d -m 0755 %{buildroot}%{_sysconfdir}/security
install -m 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/security/pam_winbind.conf

install -d -m 0755 %{buildroot}%{_sysconfdir}/pam.d
install -m 0644 %{SOURCE6} %{buildroot}%{_sysconfdir}/pam.d/samba

echo 127.0.0.1 localhost > %{buildroot}%{_sysconfdir}/samba/lmhosts

# openLDAP database schema
install -d -m 0755 %{buildroot}%{_sysconfdir}/openldap/schema
install -m644 examples/LDAP/samba.schema %{buildroot}%{_sysconfdir}/openldap/schema/samba.schema

install -m 0744 packaging/printing/smbprint %{buildroot}%{_bindir}/smbprint

#install -d -m 0755 %{buildroot}%{_tmpfilesdir}/
#echo "d /run/samba  755 root root" >> %{buildroot}%{_tmpfilesdir}/samba.conf

%if %{with_clustering_support}
#echo "d /run/ctdb 755 root root" >> %{buildroot}%{_tmpfilesdir}/ctdb.conf
%endif

%if %{with_clustering_support}
#install -m 0644 ctdb/config/ctdb.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/ctdb
%endif

install -m 0644 %{SOURCE201} packaging/README.downgrade

%if ! %{with_dc}
install -m 0644 %{SOURCE200} packaging/README.dc
install -m 0644 %{SOURCE200} packaging/README.dc-libs
%endif

# winbind krb5 locator
install -d -m 0755 %{buildroot}%{_libdir}/krb5/plugins/libkrb5
touch %{buildroot}%{_libdir}/krb5/plugins/libkrb5/winbind_krb5_locator.so

mkdir -p %{buildroot}/var/lib/samba/msg

#install services
install -m 0755 %SOURCE300 %{buildroot}/%{_initrddir}/winbind
install -m 0755 %SOURCE301 %{buildroot}/%{_initrddir}/smb
install -m 0755 %SOURCE303 %{buildroot}/%{_initrddir}/samba
touch %buildroot/%{_libexecdir}/samba/cups_backend_smb

mkdir -p %buildroot/%{_sysconfdir}/sysconfig
touch %buildroot/%{_sysconfdir}/sysconfig/samba

%pre server
%_pre_useradd %{name} /dev/null /bin/false

%post server
%_post_service smb
chkconfig smb on

%post dc
%_post_service samba
chkconfig samba on

%preun server
%_preun_service smb

%preun dc
%_preun_service samba

%postun server
%_postun_userdel %{name}

%postun dc

%post common
#%_tmpfilescreate %{name}
if [ -d /var/cache/samba ]; then
    mv /var/cache/samba/netsamlogon_cache.tdb /var/lib/samba/ 2>/dev/null
    mv /var/cache/samba/winbindd_cache.tdb /var/lib/samba/ 2>/dev/null
    rm -rf /var/cache/samba/
    ln -sf /var/cache/samba /var/lib/samba/
fi

### CLIENT
%post client
%{_sbindir}/update-alternatives --install %{_libexecdir}/samba/cups_backend_smb \
	cups_backend_smb \
	%{_bindir}/smbspool 10

%postun client
if [ $1 -eq 0 ] ; then
   %{_sbindir}/update-alternatives --remove cups_backend_smb %{_libexecdir}/samba/smbspool
fi

### KRB5-PRINTING
%post krb5-printing
%{_sbindir}/update-alternatives --install %{_libexecdir}/samba/cups_backend_smb \
	cups_backend_smb \
	%{_libexecdir}/samba/smbspool_krb5_wrapper 50

%postun krb5-printing
if [ $1 -eq 0 ] ; then
   %{_sbindir}/update-alternatives --remove cups_backend_smb %{_libexecdir}/samba/smbspool_krb5_wrapper
fi

%pre winbind
%_pre_groupadd wbpriv

%postun winbind
%_postun_groupdel wbpriv

%post winbind
%_post_service winbind


### SAMBA
%files server

%{_initrddir}/smb

%doc COPYING README.md WHATSNEW.txt
%doc examples/autofs examples/LDAP examples/misc
%doc examples/printer-accounting examples/printing
%doc packaging/README.downgrade
%{_bindir}/smbstatus
%{_sbindir}/eventlogadm
%{_sbindir}/nmbd
%{_sbindir}/smbd
%dir %{_libdir}/samba/auth
%{_libdir}/samba/auth/unix.so
%dir %{_libdir}/samba/vfs
%{_libdir}/samba/vfs/acl_tdb.so
%{_libdir}/samba/vfs/acl_xattr.so
%{_libdir}/samba/vfs/aio_fork.so
%{_libdir}/samba/vfs/aio_pthread.so
%{_libdir}/samba/vfs/audit.so
%{_libdir}/samba/vfs/btrfs.so
%{_libdir}/samba/vfs/cap.so
%{_libdir}/samba/vfs/catia.so
%{_libdir}/samba/vfs/commit.so
%{_libdir}/samba/vfs/crossrename.so
%{_libdir}/samba/vfs/default_quota.so
%{_libdir}/samba/vfs/dirsort.so
%{_libdir}/samba/vfs/expand_msdfs.so
%{_libdir}/samba/vfs/extd_audit.so
%{_libdir}/samba/vfs/fake_perms.so
%{_libdir}/samba/vfs/fileid.so
%{_libdir}/samba/vfs/fruit.so
%{_libdir}/samba/vfs/full_audit.so
%{_libdir}/samba/vfs/glusterfs_fuse.so
%{_libdir}/samba/vfs/gpfs.so
%{_libdir}/samba/vfs/linux_xfs_sgid.so
%{_libdir}/samba/vfs/media_harmony.so
%{_libdir}/samba/vfs/offline.so
%{_libdir}/samba/vfs/preopen.so
%{_libdir}/samba/vfs/readahead.so
%{_libdir}/samba/vfs/readonly.so
%{_libdir}/samba/vfs/recycle.so
%{_libdir}/samba/vfs/shadow_copy.so
%{_libdir}/samba/vfs/shadow_copy2.so
%{_libdir}/samba/vfs/snapper.so
%{_libdir}/samba/vfs/streams_depot.so
%{_libdir}/samba/vfs/streams_xattr.so
%{_libdir}/samba/vfs/syncops.so
%{_libdir}/samba/vfs/time_audit.so
%{_libdir}/samba/vfs/virusfilter.so
%{_libdir}/samba/vfs/widelinks.so
%{_libdir}/samba/vfs/worm.so
%{_libdir}/samba/vfs/xattr_tdb.so

%{_libexecdir}/samba/samba-bgqd
%{_libexecdir}/samba/samba-dcerpcd
%{_libexecdir}/samba/rpcd_classic
%{_libexecdir}/samba/rpcd_epmapper
%{_libexecdir}/samba/rpcd_fsrvp
%{_libexecdir}/samba/rpcd_lsad
%{_libexecdir}/samba/rpcd_mdssvc
%{_libexecdir}/samba/rpcd_rpcecho
%{_libexecdir}/samba/rpcd_spoolss
%{_libexecdir}/samba/rpcd_winreg

%dir %{_datadir}/samba
%dir %{_datadir}/samba/mdssvc
%{_datadir}/samba/mdssvc/elasticsearch_mappings.json

%attr(1777,root,root) %dir /var/spool/samba
%dir %{_sysconfdir}/openldap/schema
%{_sysconfdir}/openldap/schema/samba.schema
%{_sysconfdir}/pam.d/samba
%{_mandir}/man1/smbstatus.1*
%{_mandir}/man8/eventlogadm.8*
%{_mandir}/man8/samba-bgqd.8*
%{_mandir}/man8/samba-dcerpcd.8*
%{_mandir}/man8/smbd.8*
%{_mandir}/man8/nmbd.8*
%{_mandir}/man8/vfs_acl_tdb.8*
%{_mandir}/man8/vfs_acl_xattr.8*
%{_mandir}/man8/vfs_aio_fork.8*
%{_mandir}/man8/vfs_aio_pthread.8*
%{_mandir}/man8/vfs_audit.8*
%{_mandir}/man8/vfs_btrfs.8*
%{_mandir}/man8/vfs_cap.8*
%{_mandir}/man8/vfs_catia.8*
%{_mandir}/man8/vfs_commit.8*
%{_mandir}/man8/vfs_crossrename.8*
%{_mandir}/man8/vfs_default_quota.8*
%{_mandir}/man8/vfs_dirsort.8*
%{_mandir}/man8/vfs_extd_audit.8*
%{_mandir}/man8/vfs_fake_perms.8*
%{_mandir}/man8/vfs_fileid.8*
%{_mandir}/man8/vfs_fruit.8*
%{_mandir}/man8/vfs_full_audit.8*
%{_mandir}/man8/vfs_glusterfs_fuse.8*
%{_mandir}/man8/vfs_gpfs.8*
%{_mandir}/man8/vfs_expand_msdfs.8.*
%{_mandir}/man8/vfs_linux_xfs_sgid.8*
%{_mandir}/man8/vfs_media_harmony.8*
%{_mandir}/man8/vfs_preopen.8*
%{_mandir}/man8/vfs_readahead.8*
%{_mandir}/man8/vfs_readonly.8*
%{_mandir}/man8/vfs_recycle.8*
%{_mandir}/man8/vfs_shadow_copy.8*
%{_mandir}/man8/vfs_shadow_copy2.8*
%{_mandir}/man8/vfs_snapper.8*
%{_mandir}/man8/vfs_streams_depot.8*
%{_mandir}/man8/vfs_streams_xattr.8*
%{_mandir}/man8/vfs_syncops.8*
%{_mandir}/man8/vfs_time_audit.8*
%{_mandir}/man8/vfs_virusfilter.8*
%{_mandir}/man8/vfs_widelinks.8*
%{_mandir}/man8/vfs_worm.8*
%{_mandir}/man8/vfs_xattr_tdb.8*
%{_libdir}/samba/vfs/io_uring.so
%{_mandir}/man8/vfs_io_uring.8*

### CLIENT
%files client
%{_bindir}/cifsdd
%{_bindir}/mdsearch
%{_bindir}/mvxattr
%{_bindir}/dbwrap_tool
%{_bindir}/dumpmscat
%{_bindir}/nmblookup
%{_bindir}/oLschema2ldif
%{_bindir}/regdiff
%{_bindir}/regpatch
%{_bindir}/regshell
%{_bindir}/regtree
%{_bindir}/rpcclient
%{_bindir}/samba-regedit
%{_bindir}/sharesec
%{_bindir}/smbcacls
%{_bindir}/smbclient
%{_bindir}/smbcquotas
%{_bindir}/smbget
%{_bindir}/smbprint
%{_bindir}/smbspool
%{_bindir}/smbtar
%{_bindir}/smbtree
%dir %{_libexecdir}/samba
%{_libexecdir}/samba/cups_backend_smb
%{_mandir}/man1/mdsearch.1*
%{_mandir}/man1/mvxattr.1*
%{_mandir}/man1/dbwrap_tool.1*
%{_mandir}/man1/nmblookup.1*
%{_mandir}/man1/oLschema2ldif.1*
%{_mandir}/man1/regdiff.1*
%{_mandir}/man1/regpatch.1*
%{_mandir}/man1/regshell.1*
%{_mandir}/man1/regtree.1*
%{_mandir}/man1/log2pcap.1*
%{_mandir}/man1/rpcclient.1*
%{_mandir}/man1/sharesec.1*
%{_mandir}/man1/smbcacls.1*
%{_mandir}/man1/smbclient.1*
%{_mandir}/man1/smbcquotas.1*
%{_mandir}/man1/smbget.1*
## we don't build it for now
%if %{with_internal_ntdb}
%{_mandir}/man3/ntdb.3*
%{_mandir}/man8/ntdbbackup.8*
%{_mandir}/man8/ntdbdump.8*
%{_mandir}/man8/ntdbrestore.8*
%{_mandir}/man8/ntdbtool.8*
%endif
%{_mandir}/man5/smbgetrc.5*
%{_mandir}/man1/smbtar.1*
%{_mandir}/man1/smbtree.1*
%{_mandir}/man8/samba-regedit.8*
%{_mandir}/man8/smbspool.8*
%{_mandir}/man8/cifsdd.8*
%{_mandir}/man8/vfs_offline.8*

## we don't build it for now
%if %{with_internal_ntdb}
%{_bindir}/ntdbbackup
%{_bindir}/ntdbdump
%{_bindir}/ntdbrestore
%{_bindir}/ntdbtool
%endif

%if %{with_internal_tdb}
%{_bindir}/tdbbackup
%{_bindir}/tdbdump
%{_bindir}/tdbrestore
%{_bindir}/tdbtool
%{_mandir}/man8/tdbbackup.8*
%{_mandir}/man8/tdbdump.8*
%{_mandir}/man8/tdbrestore.8*
%{_mandir}/man8/tdbtool.8*
%endif

%if %{with_internal_ldb}
%{_bindir}/ldbadd
%{_bindir}/ldbdel
%{_bindir}/ldbedit
%{_bindir}/ldbmodify
%{_bindir}/ldbrename
%{_bindir}/ldbsearch
%{_libdir}/samba/libldb-cmdline-samba4.so
%dir %{_libdir}/samba/ldb
%{_libdir}/samba/ldb/asq.so
%{_libdir}/samba/ldb/dsdb_notification.so
%{_libdir}/samba/ldb/paged_results.so
%{_libdir}/samba/ldb/paged_searches.so
%{_libdir}/samba/ldb/rdn_name.so
%{_libdir}/samba/ldb/sample.so
%{_libdir}/samba/ldb/server_sort.so
%{_libdir}/samba/ldb/skel.so
%{_libdir}/samba/ldb/tdb.so
%{_libdir}/samba/ldb/vlv.so
%{_mandir}/man1/ldbadd.1*
%{_mandir}/man1/ldbdel.1*
%{_mandir}/man1/ldbedit.1*
%{_mandir}/man1/ldbmodify.1*
%{_mandir}/man1/ldbrename.1*
%{_mandir}/man1/ldbsearch.1*
%endif

### COMMON
%files common

%dir %{_sysconfdir}/logrotate.d/
%config(noreplace) %{_sysconfdir}/logrotate.d/samba
%attr(0700,root,root) %dir /var/log/samba
%attr(0700,root,root) %dir /var/log/samba/old
%attr(755,root,root) %dir /var/run/samba
%dir /run/winbindd
%dir /var/lib/samba
%attr(700,root,root) %dir /var/lib/samba/private
%attr(755,root,root) %dir /var/lib/samba/msg
%dir /var/lib/samba/lock
%attr(755,root,root) %dir %{_sysconfdir}/samba
%config(noreplace) %{_sysconfdir}/samba/smb.conf
%config(noreplace) %{_sysconfdir}/samba/lmhosts
%config(noreplace) %{_sysconfdir}/sysconfig/samba
%{_bindir}/net
%{_bindir}/pdbedit
%{_bindir}/profiles
%{_bindir}/smbcontrol
%{_bindir}/smbpasswd
%{_bindir}/testparm
%{_mandir}/man1/profiles.1*
%{_mandir}/man1/smbcontrol.1*
%{_mandir}/man1/testparm.1*
%{_mandir}/man5/lmhosts.5*
%{_mandir}/man5/smb.conf.5*
%{_mandir}/man5/smbpasswd.5*
%{_mandir}/man7/samba.7*
%{_mandir}/man7/traffic*.7*
%{_mandir}/man8/net.8*
%{_mandir}/man8/pdbedit.8*
%{_mandir}/man8/smbpasswd.8*

# common libraries

%dir %{_libdir}/samba/pdb
%{_libdir}/samba/pdb/ldapsam.so
%{_libdir}/samba/pdb/smbpasswd.so
%{_libdir}/samba/pdb/tdbsam.so
#{_libdir}/samba/pdb/wbc_sam.so

### DC
%files dc

%if %{with_dc}

%{_initrddir}/samba

%{_bindir}/samba-tool
%{_sbindir}/samba
%{_sbindir}/samba_kcc
%{_sbindir}/samba_dnsupdate
%{_sbindir}/samba_downgrade_db
%{_sbindir}/samba_spnupdate
%{_sbindir}/samba_upgradedns
%{_sbindir}/samba-gpupdate
%{_libdir}/samba/auth/samba4.so
%{_libdir}/samba/bind9/dlz_bind9_10.so
%{_libdir}/samba/bind9/dlz_bind9_11.so
%{_libdir}/samba/bind9/dlz_bind9_12.so
%{_libdir}/samba/bind9/dlz_bind9_14.so
%{_libdir}/samba/bind9/dlz_bind9_16.so
%{_libdir}/samba/bind9/dlz_bind9_18.so
%dir %{_libdir}/samba/gensec
%{_libdir}/samba/gensec/krb5.so
%{_libdir}/samba/ldb/acl.so
%{_libdir}/samba/ldb/aclread.so
%{_libdir}/samba/ldb/anr.so
%{_libdir}/samba/ldb/audit_log.so
%{_libdir}/samba/ldb/count_attrs.so
%{_libdir}/samba/ldb/descriptor.so
%{_libdir}/samba/ldb/dirsync.so
%{_libdir}/samba/ldb/dsdb_notification.so
%{_libdir}/samba/ldb/encrypted_secrets.so
%{_libdir}/samba/ldb/extended_dn_in.so
%{_libdir}/samba/ldb/extended_dn_out.so
%{_libdir}/samba/ldb/extended_dn_store.so
%{_libdir}/samba/ldb/group_audit_log.so
%{_libdir}/samba/ldb/ildap.so
%{_libdir}/samba/ldb/instancetype.so
%{_libdir}/samba/ldb/lazy_commit.so
%{_libdir}/samba/ldb/ldbsamba_extensions.so
%{_libdir}/samba/ldb/linked_attributes.so
%{_libdir}/samba/ldb/new_partition.so
%{_libdir}/samba/ldb/objectclass.so
%{_libdir}/samba/ldb/objectclass_attrs.so
%{_libdir}/samba/ldb/objectguid.so
%{_libdir}/samba/ldb/operational.so
%{_libdir}/samba/ldb/paged_results.so
%{_libdir}/samba/ldb/partition.so
%{_libdir}/samba/ldb/password_hash.so
%{_libdir}/samba/ldb/ranged_results.so
%{_libdir}/samba/ldb/repl_meta_data.so
%{_libdir}/samba/ldb/resolve_oids.so
%{_libdir}/samba/ldb/rootdse.so
%{_libdir}/samba/ldb/samba3sam.so
%{_libdir}/samba/ldb/samba3sid.so
%{_libdir}/samba/ldb/samba_dsdb.so
%{_libdir}/samba/ldb/samba_secrets.so
%{_libdir}/samba/ldb/samldb.so
%{_libdir}/samba/ldb/schema_data.so
%{_libdir}/samba/ldb/schema_load.so
%{_libdir}/samba/ldb/secrets_tdb_sync.so
%{_libdir}/samba/ldb/show_deleted.so
%{_libdir}/samba/ldb/subtree_delete.so
%{_libdir}/samba/ldb/subtree_rename.so
%{_libdir}/samba/ldb/unique_object_sids.so
%{_libdir}/samba/ldb/update_keytab.so
%{_libdir}/samba/ldb/vlv.so
%{_libdir}/samba/ldb/wins_ldb.so
%{_libdir}/samba/ldb/dns_notify.so
%{_libdir}/samba/ldb/tombstone_reanimate.so
%{_libdir}/samba/vfs/posix_eadb.so
%dir /var/lib/samba/sysvol
%{_datadir}/samba/setup
%{_datadir}/samba/admx
%{_mandir}/man8/samba.8*
%{_mandir}/man8/samba_downgrade_db.8*
%{_mandir}/man8/samba-tool.8*
%{_mandir}/man8/samba-gpupdate.8*
%else # with_dc
%doc packaging/README.dc
%exclude %{_mandir}/man8/samba.8*
%exclude %{_mandir}/man8/samba_downgrade_db.8*
%exclude %{_mandir}/man8/samba-tool.8*
%exclude %{_libdir}/samba/ldb/ildap.so
%exclude %{_libdir}/samba/ldb/ldbsamba_extensions.so

%endif # with_dc

### DC-LIBS
%files -n %{libsdc}

%if %{with_dc}
%{_libdir}/samba/libpac-samba4.so
%{_libdir}/samba/libprocess-model-samba4.so
%{_libdir}/samba/libservice-samba4.so
%dir %{_libdir}/samba/process_model
%{_libdir}/samba/process_model/*.so
%dir %{_libdir}/samba/service
%{_libdir}/samba/service/cldap.so
%{_libdir}/samba/service/dcerpc.so
%{_libdir}/samba/service/dns.so
%{_libdir}/samba/service/dns_update.so
%{_libdir}/samba/service/drepl.so
%{_libdir}/samba/service/kcc.so
%{_libdir}/samba/service/kdc.so
%{_libdir}/samba/service/ldap.so
%{_libdir}/samba/service/nbtd.so
%{_libdir}/samba/service/ntp_signd.so
%{_libdir}/samba/service/s3fs.so
%{_libdir}/samba/service/winbindd.so
%{_libdir}/samba/service/wrepl.so
%{_libdir}/libdcerpc-server.so.%{dcmajor}
%{_libdir}/libdcerpc-server.so.%{dcmajor}.*
%{_libdir}/libdcerpc-server-core.so.%{dcmajor}
%{_libdir}/libdcerpc-server-core.so.%{dcmajor}.*
%{_libdir}/samba/libclidns-samba4.so
%{_libdir}/samba/libdfs-server-ad-samba4.so
%{_libdir}/samba/libdnsserver-common-samba4.so
%{_libdir}/samba/libdsdb-module-samba4.so
%{_libdir}/samba/libposix-eadb-samba4.so
%{_libdir}/samba/libkdc-samba4.so
%{_libdir}/samba/libheimntlm-samba4.so
%else
%doc packaging/README.dc-libs
%exclude %{_libdir}/samba/libdfs-server-ad-samba4.so
%exclude %{_libdir}/samba/libdnsserver-common-samba4.so
%endif # with_dc

%if %{with_dc}
%files -n %{libkdc}

%files -n %{libheimntlm}
%endif

### DEVEL
%files -n %{develname}
%{_includedir}/samba-4.0/charset.h
%{_includedir}/samba-4.0/core/doserr.h
%{_includedir}/samba-4.0/core/error.h
%{_includedir}/samba-4.0/core/hresult.h
%{_includedir}/samba-4.0/core/ntstatus.h
%{_includedir}/samba-4.0/core/ntstatus_gen.h
%{_includedir}/samba-4.0/core/werror.h
%{_includedir}/samba-4.0/core/werror_gen.h
%{_includedir}/samba-4.0/credentials.h
%{_includedir}/samba-4.0/dcerpc.h
%{_includedir}/samba-4.0/dcesrv_core.h
%{_includedir}/samba-4.0/domain_credentials.h
%{_includedir}/samba-4.0/gen_ndr/atsvc.h
%{_includedir}/samba-4.0/gen_ndr/auth.h
%{_includedir}/samba-4.0/gen_ndr/dcerpc.h
%{_includedir}/samba-4.0/gen_ndr/krb5pac.h
%{_includedir}/samba-4.0/gen_ndr/lsa.h
%{_includedir}/samba-4.0/gen_ndr/misc.h
%{_includedir}/samba-4.0/gen_ndr/nbt.h
%{_includedir}/samba-4.0/gen_ndr/drsblobs.h
%{_includedir}/samba-4.0/gen_ndr/drsuapi.h
%{_includedir}/samba-4.0/gen_ndr/ndr_drsblobs.h
%{_includedir}/samba-4.0/gen_ndr/ndr_drsuapi.h
%{_includedir}/samba-4.0/gen_ndr/ndr_atsvc.h
%{_includedir}/samba-4.0/gen_ndr/ndr_dcerpc.h
%{_includedir}/samba-4.0/gen_ndr/ndr_krb5pac.h
%{_includedir}/samba-4.0/gen_ndr/ndr_misc.h
%{_includedir}/samba-4.0/gen_ndr/ndr_nbt.h
%{_includedir}/samba-4.0/gen_ndr/ndr_samr.h
%{_includedir}/samba-4.0/gen_ndr/ndr_samr_c.h
%{_includedir}/samba-4.0/gen_ndr/ndr_svcctl.h
%{_includedir}/samba-4.0/gen_ndr/ndr_svcctl_c.h
%{_includedir}/samba-4.0/gen_ndr/netlogon.h
%{_includedir}/samba-4.0/gen_ndr/samr.h
%{_includedir}/samba-4.0/gen_ndr/security.h
%{_includedir}/samba-4.0/gen_ndr/server_id.h
%{_includedir}/samba-4.0/gen_ndr/svcctl.h
%{_includedir}/samba-4.0/ldb_wrap.h
%{_includedir}/samba-4.0/lookup_sid.h
%{_includedir}/samba-4.0/machine_sid.h
%{_includedir}/samba-4.0/ndr.h
%dir %{_includedir}/samba-4.0/ndr
%{_includedir}/samba-4.0/ndr/ndr_dcerpc.h
%{_includedir}/samba-4.0/ndr/ndr_drsblobs.h
%{_includedir}/samba-4.0/ndr/ndr_krb5pac.h
%{_includedir}/samba-4.0/ndr/ndr_drsuapi.h
%{_includedir}/samba-4.0/ndr/ndr_svcctl.h
%{_includedir}/samba-4.0/ndr/ndr_nbt.h
%{_includedir}/samba-4.0/netapi.h
%{_includedir}/samba-4.0/param.h
%{_includedir}/samba-4.0/passdb.h
%{_includedir}/samba-4.0/policy.h
%{_includedir}/samba-4.0/rpc_common.h
%{_includedir}/samba-4.0/samba/session.h
%{_includedir}/samba-4.0/samba/version.h
%{_includedir}/samba-4.0/share.h
%{_includedir}/samba-4.0/smbconf.h
%{_includedir}/samba-4.0/smb2_lease_struct.h
%{_includedir}/samba-4.0/smb_ldap.h
%{_includedir}/samba-4.0/smbldap.h
%{_includedir}/samba-4.0/tdr.h
%{_includedir}/samba-4.0/tsocket.h
%{_includedir}/samba-4.0/tsocket_internal.h
%dir %{_includedir}/samba-4.0/util
%{_includedir}/samba-4.0/util/attr.h
%{_includedir}/samba-4.0/util/blocking.h
%{_includedir}/samba-4.0/util/data_blob.h
%{_includedir}/samba-4.0/util/debug.h
%{_includedir}/samba-4.0/util/discard.h
%{_includedir}/samba-4.0/util/fault.h
%{_includedir}/samba-4.0/util/idtree.h
%{_includedir}/samba-4.0/util/idtree_random.h
%{_includedir}/samba-4.0/util/signal.h
%{_includedir}/samba-4.0/util/substitute.h
%{_includedir}/samba-4.0/util/tevent_ntstatus.h
%{_includedir}/samba-4.0/util/tevent_unix.h
%{_includedir}/samba-4.0/util/tevent_werror.h
%{_includedir}/samba-4.0/util/tfork.h
%{_includedir}/samba-4.0/util/time.h
%{_includedir}/samba-4.0/util_ldb.h
%{_includedir}/samba-4.0/util/genrand.h
%{_libdir}/libdcerpc-binding.so
%{_libdir}/libdcerpc-samr.so
%{_libdir}/libdcerpc.so
%{_libdir}/libndr-krb5pac.so
%{_libdir}/libndr-nbt.so
%{_libdir}/libndr-standard.so
%{_libdir}/libndr.so
%{_libdir}/libnetapi.so
%{_libdir}/libsamba-credentials.so
%{_libdir}/libsamba-hostconfig.so
%{_libdir}/libsamba-util.so
%{_libdir}/libsamdb.so
%{_libdir}/libsmbconf.so
%{_libdir}/libtevent-util.so
%{_libdir}/pkgconfig/dcerpc.pc
%{_libdir}/pkgconfig/dcerpc_samr.pc
%{_libdir}/pkgconfig/ndr.pc
%{_libdir}/pkgconfig/ndr_krb5pac.pc
%{_libdir}/pkgconfig/ndr_nbt.pc
%{_libdir}/pkgconfig/ndr_standard.pc
%{_libdir}/pkgconfig/netapi.pc
%{_libdir}/pkgconfig/samba-credentials.pc
%{_libdir}/pkgconfig/samba-hostconfig.pc
%{_libdir}/pkgconfig/samba-util.pc
%{_libdir}/pkgconfig/samdb.pc
%{_libdir}/libsamba-passdb.so
%{_libdir}/libsmbldap.so
%{_libdir}/libsamba-errors.so

%if %{with_dc}
%{_includedir}/samba-4.0/dcerpc_server.h
%{_libdir}/libdcerpc-server.so
%{_libdir}/libdcerpc-server-core.so
%{_libdir}/pkgconfig/dcerpc_server.pc

%{_libdir}/libsamba-policy.*.so
%{_libdir}/pkgconfig/samba-policy.*.pc
%endif

%if %{with_internal_talloc}
%{_includedir}/samba-4.0/pytalloc.h
%endif

%if ! %{with_libsmbclient}
%{_includedir}/samba-4.0/libsmbclient.h
%endif # ! with_libsmbclient

%if ! %{with_libwbclient}
%{_includedir}/samba-4.0/wbclient.h
%endif # ! with_libwbclient

### VFS-CEPHFS
%if %{with_vfs_cephfs}
%files vfs-cephfs
%{_libdir}/samba/vfs/ceph.so
%{_mandir}/man8/vfs_ceph.8*
%endif

### VFS-GLUSTERFS
%if %{with_vfs_glusterfs}
%files vfs-glusterfs
%{_libdir}/samba/vfs/glusterfs.so
%{_mandir}/man8/vfs_glusterfs.8*
%endif

### KRB5-PRINTING
%files krb5-printing
%defattr(-,root,root)
%attr(0700,root,root) %{_libexecdir}/samba/smbspool_krb5_wrapper
%{_mandir}/man8/smbspool_krb5_wrapper.8*

### LIBS
%files -n %{libname}
%{_libdir}/libdcerpc-samr.so.*
%{_libdir}/libsamba-policy.*.so.*

# libraries needed by the public libraries
%{_libdir}/samba/libMESSAGING-samba4.so
%{_libdir}/samba/libMESSAGING-SEND-samba4.so
%{_libdir}/samba/libLIBWBCLIENT-OLD-samba4.so
%{_libdir}/samba/libauth4-samba4.so
%{_libdir}/samba/libauth-unix-token-samba4.so
%{_libdir}/samba/libcommon-auth-samba4.so
%{_libdir}/samba/libdcerpc-samba4.so
%{_libdir}/samba/libprinter-driver-samba4.so
%{_libdir}/samba/libsamba-net.*-samba4.so
%{_libdir}/samba/libsamba-python.*-samba4.so
%{_libdir}/samba/libshares-samba4.so
%{_libdir}/samba/libsmbpasswdparser-samba4.so
%{_libdir}/samba/libxattr-tdb-samba4.so

%if %{with_dc}
%{_libdir}/samba/libdb-glue-samba4.so
%{_libdir}/samba/libHDB-SAMBA4-samba4.so
%{_libdir}/samba/libasn1-samba4.so
%{_libdir}/samba/libgssapi-samba4.so
%{_libdir}/samba/libhcrypto-samba4.so
%{_libdir}/samba/libhdb-samba4.so
%{_libdir}/samba/libheimbase-samba4.so
%{_libdir}/samba/libhx509-samba4.so
%{_libdir}/samba/libkrb5-samba4.so
%{_libdir}/samba/libroken-samba4.so
%{_libdir}/samba/libwind-samba4.so
%endif

%{_libdir}/libdcerpc-binding.so.*
%{_libdir}/libndr.so.*
%{_libdir}/libndr-krb5pac.so.*
%{_libdir}/libndr-nbt.so.*
%{_libdir}/libndr-standard.so.*
%{_libdir}/libnetapi.so.*
%{_libdir}/libsamba-credentials.so.*
%{_libdir}/libsamba-passdb.so.*
%{_libdir}/libsamba-util.so.*
%{_libdir}/libsamba-hostconfig.so.*
%{_libdir}/libsamdb.so.*
%{_libdir}/libsmbconf.so.*
%{_libdir}/libsmbldap.so.*
%{_libdir}/libtevent-util.so.*
%{_libdir}/libdcerpc.so.*
%{_libdir}/libsamba-errors.so.*

%dir %{_libdir}/samba
%{_libdir}/samba/libCHARSET3-samba4.so
%{_libdir}/samba/libREG-FULL-samba4.so
%{_libdir}/samba/libRPC-SERVER-LOOP-samba4.so
%{_libdir}/samba/libRPC-WORKER-samba4.so
%{_libdir}/samba/libaddns-samba4.so
%{_libdir}/samba/libads-samba4.so
%{_libdir}/samba/libasn1util-samba4.so
#{_libdir}/samba/libauth-sam-reply-samba4.so
%{_libdir}/samba/libauth-samba4.so
%{_libdir}/samba/libauthkrb5-samba4.so
%{_libdir}/samba/libcli-cldap-samba4.so
%{_libdir}/samba/libcli-ldap-common-samba4.so
%{_libdir}/samba/libcli-ldap-samba4.so
%{_libdir}/samba/libcli-nbt-samba4.so
%{_libdir}/samba/libcli-smb-common-samba4.so
%{_libdir}/samba/libcli-spoolss-samba4.so
%{_libdir}/samba/libcliauth-samba4.so
%{_libdir}/samba/libcluster-samba4.so
%{_libdir}/samba/libcmdline-samba4.so
%{_libdir}/samba/libcmdline-contexts-samba4.so
%{_libdir}/samba/libdbwrap-samba4.so
%{_libdir}/samba/libdcerpc-pkt-auth-samba4.so
%{_libdir}/samba/libdcerpc-samba-samba4.so
%{_libdir}/samba/libscavenge-dns-records-samba4.so
%{_libdir}/samba/libdsdb-garbage-collect-tombstones-samba4.so
%{_libdir}/samba/libevents-samba4.so
%{_libdir}/samba/libflag-mapping-samba4.so
%{_libdir}/samba/libgpext-samba4.so
%{_libdir}/samba/libgpo-samba4.so
%{_libdir}/samba/libgse-samba4.so
%{_libdir}/samba/libhttp-samba4.so
%{_libdir}/samba/libinterfaces-samba4.so
%{_libdir}/samba/libkrb5samba-samba4.so
%{_libdir}/samba/libldbsamba-samba4.so
%{_libdir}/samba/liblibcli-lsa3-samba4.so
%{_libdir}/samba/liblibcli-netlogon3-samba4.so
%{_libdir}/samba/liblibsmb-samba4.so
%{_libdir}/samba/libmsrpc3-samba4.so
%{_libdir}/samba/libndr-samba-samba4.so
%{_libdir}/samba/libndr-samba4.so
%{_libdir}/samba/libnet-keytab-samba4.so
%{_libdir}/samba/libnetif-samba4.so
%{_libdir}/samba/libnpa-tstream-samba4.so
%{_libdir}/samba/libprinting-migrate-samba4.so
%{_libdir}/samba/libreplace-samba4.so
%{_libdir}/samba/libsamba-cluster-support-samba4.so
%{_libdir}/samba/libsamba-debug-samba4.so
%{_libdir}/samba/libsamba-modules-samba4.so
%{_libdir}/samba/libsamba-security-samba4.so
%{_libdir}/samba/libsamba-sockets-samba4.so
%{_libdir}/samba/libsamba3-util-samba4.so
%{_libdir}/samba/libsamdb-common-samba4.so
%{_libdir}/samba/libsecrets3-samba4.so
%{_libdir}/samba/libserver-role-samba4.so
%{_libdir}/samba/libsmb-transport-samba4.so
%{_libdir}/samba/libsmbd-base-samba4.so
%{_libdir}/samba/libsmbd-shim-samba4.so
%{_libdir}/samba/libsmbldaphelper-samba4.so
%{_libdir}/samba/libsocket-blocking-samba4.so
%{_libdir}/samba/libtdb-wrap-samba4.so
%{_libdir}/samba/libtrusts-util-samba4.so
%{_libdir}/samba/libutil-reg-samba4.so
%{_libdir}/samba/libutil-setid-samba4.so
%{_libdir}/samba/libutil-tdb-samba4.so
#{_libdir}/samba/libwinbind-client-samba4.so
%{_libdir}/samba/libgenrand-samba4.so
%{_libdir}/samba/libiov-buf-samba4.so
%{_libdir}/samba/libmessages-dgm-samba4.so
%{_libdir}/samba/libmessages-util-samba4.so
%{_libdir}/samba/libmscat-samba4.so
%{_libdir}/samba/libmsghdr-samba4.so
%{_libdir}/samba/libserver-id-db-samba4.so
%{_libdir}/samba/libsys-rw-samba4.so
%{_libdir}/samba/libtalloc-report-samba4.so
%{_libdir}/samba/libtalloc-report-printf-samba4.so
%{_libdir}/samba/libtime-basic-samba4.so
%{_libdir}/samba/vfs/shell_snap.so
%{_libdir}/samba/vfs/unityed_media.so

%{_libdir}/samba/libcom-err-samba4.so
%{_libdir}/samba/libgensec-samba4.so
%{_libdir}/samba/libgss-preauth-samba4.so
%{_libdir}/samba/libregistry-samba4.so
%{_libdir}/samba/libsmbclient-raw-samba4.so
%{_libdir}/samba/libtorture-samba4.so

%{_mandir}/man8/vfs_shell_snap.8.*
%{_mandir}/man8/vfs_unityed_media.8.*

%if ! %{with_libwbclient}
%{_libdir}/samba/libwbclient.so.*
%{_libdir}/samba/libwinbind-client-samba4.so
%endif # ! with_libwbclient

%if ! %{with_libsmbclient}
%{_libdir}/samba/libsmbclient.so.*
%{_mandir}/man7/libsmbclient.7*
%endif # ! with_libsmbclient

%if %{with_internal_ntdb}
%{_libdir}/samba/libntdb.so.1
%{_libdir}/samba/libntdb.so.%{ntdb_version}
%endif

%if %{with_internal_talloc}
%{_libdir}/samba/libtalloc.so.2
%{_libdir}/samba/libtalloc.so.%{talloc_version}
%{_libdir}/samba/libpytalloc-util.so.2
%{_libdir}/samba/libpytalloc-util.so.%{talloc_version}
%{_mandir}/man3/talloc.3*
%endif

%if %{with_internal_tevent}
%{_libdir}/samba/libtevent.so.0
%{_libdir}/samba/libtevent.so.%{tevent_version}
%endif

%if %{with_internal_tdb}
%{_libdir}/samba/libtdb.so.1
%{_libdir}/samba/libtdb.so.%{tdb_version}
%endif

%if %{with_internal_ldb}
%{_libdir}/samba/libldb.so.1
%{_libdir}/samba/libldb.so.%{ldb_version}
%{_libdir}/samba/ldb.so
%{_libdir}/samba/mdb.so
%{_libdir}/samba/libldb-key-value-samba4.so
%{_libdir}/samba/libldb-mdb-int-samba4.so
%{_mandir}/man3/ldb.3*
%endif

### LIBSMBCLIENT
%if %{with_libsmbclient}
%files -n %{libsmbclient}
%{_libdir}/libsmbclient.so.%{smbclientmajor}
%{_libdir}/libsmbclient.so.%{smbclientmajor}.*


### LIBSMBCLIENT-DEVEL
%files -n %{smbclientdevel}
%{_includedir}/samba-4.0/libsmbclient.h
%{_libdir}/libsmbclient.so
%{_libdir}/pkgconfig/smbclient.pc
%{_mandir}/man7/libsmbclient.7*
%endif # with_libsmbclient

### LIBWBCLIENT
%if %{with_libwbclient}
%files -n %{libwbclient}
%{_libdir}/libwbclient.so.%{wbclientmajor}
%{_libdir}/libwbclient.so.%{wbclientmajor}.*
#{_libdir}/samba/libwinbind-client-samba4.so

### LIBWBCLIENT-DEVEL
%files -n %{wbclientdevel}
%{_includedir}/samba-4.0/wbclient.h
%{_libdir}/libwbclient.so
%{_libdir}/pkgconfig/wbclient.pc
%endif # with_libwbclient

### PIDL
%files pidl


%files -n python3-samba
%{python3_sitearch}/*

### TEST
%files test
%{_bindir}/gentest
%{_bindir}/locktest
%{_bindir}/masktest
%{_bindir}/ndrdump
%{_bindir}/smbtorture
%{_mandir}/man1/gentest.1*
%{_mandir}/man1/locktest.1*
%{_mandir}/man1/masktest.1*
%{_mandir}/man1/ndrdump.1*
%{_mandir}/man1/smbtorture.1*

%if %{with testsuite}
# files to ignore in testsuite mode
%{_libdir}/samba/libnss-wrapper.so
%{_libdir}/samba/libsocket-wrapper.so
%{_libdir}/samba/libuid-wrapper.so
%endif

### TEST-LIBS
%files -n %{libtest}
%if %{with_dc}
%{_libdir}/samba/libdlz-bind9-for-torture-samba4.so
%else
%{_libdir}/samba/libdsdb-module-samba4.so
%endif

### WINBIND
%files winbind

%{_initrddir}/winbind
%{_libdir}/samba/idmap
%{_libdir}/samba/nss_info
%{_libdir}/samba/libnss-info-samba4.so
%{_libdir}/samba/libidmap-samba4.so
%{_sbindir}/winbindd
%attr(750,root,wbpriv) %dir /var/lib/samba/winbindd_privileged
%{_mandir}/man8/winbindd.8*
%{_mandir}/man8/idmap_*.8*

### WINBIND-CLIENTS
%files winbind-clients

%{_bindir}/ntlm_auth
%{_bindir}/wbinfo
%{_mandir}/man1/ntlm_auth.1.*
%{_mandir}/man1/wbinfo.1*

### WINBIND-KRB5-LOCATOR
%files winbind-krb5-locator
%ghost %{_libdir}/krb5/plugins/libkrb5/winbind_krb5_locator.so
%{_libdir}/samba/krb5/winbind_krb5_locator.so
%{_libdir}/samba/krb5/async_dns_krb5_locator.so
%{_mandir}/man8/winbind_krb5_locator.8*

### WINBIND-MODULES
%files winbind-modules
%{_libdir}/libnss_winbind.so.%{nssmajor}
%{_libdir}/libnss_wins.so.%{nssmajor}
%{_libdir}/security/pam_winbind.so
%config(noreplace) %{_sysconfdir}/security/pam_winbind.conf
%{_mandir}/man5/pam_winbind.conf.5*
%{_mandir}/man8/pam_winbind.8*

%if %{with_clustering_support}
%files -n ctdb
%config(noreplace) %{_sysconfdir}/ctdb/*.sh
%config(noreplace) %{_sysconfdir}/ctdb/functions
%dir %{_localstatedir}/lib/ctdb/

%dir %{_sysconfdir}/ctdb
%{_sysconfdir}/ctdb/statd-callout
%{_sysconfdir}/ctdb/events/notification/README
%dir %{_sysconfdir}/ctdb/nfs-checks.d
%{_sysconfdir}/ctdb/nfs-checks.d/00.portmapper.check
%{_sysconfdir}/ctdb/nfs-checks.d/10.status.check
%{_sysconfdir}/ctdb/nfs-checks.d/20.nfs.check
%{_sysconfdir}/ctdb/nfs-checks.d/30.nlockmgr.check
%{_sysconfdir}/ctdb/nfs-checks.d/40.mountd.check
%{_sysconfdir}/ctdb/nfs-checks.d/50.rquotad.check
%{_sysconfdir}/ctdb/nfs-checks.d/README
%{_sysconfdir}/ctdb/nfs-linux-kernel-callout

%{_sysconfdir}/sudoers.d/ctdb

%{_sbindir}/ctdbd
%{_sbindir}/ctdbd_wrapper
%{_bindir}/ctdb
%{_bindir}/ping_pong
%{_bindir}/ltdbtool
%{_bindir}/ctdb_diagnostics
%{_bindir}/onnode

%{_libexecdir}/ctdb/ctdb_*
%{_libexecdir}/ctdb/smnotify
%{_libexecdir}/ctdb/ctdb-*
%{_libexecdir}/ctdb/tdb_mutex_check

%{_libdir}/samba/libctdb-event-client-samba4.so

%dir %{_datadir}/ctdb/events
%{_datadir}/ctdb/events/*

%{_mandir}/man1/ctdb*.1*
%{_mandir}/man1/onnode.1*
%{_mandir}/man1/ltdbtool.1*
%{_mandir}/man1/ping_pong.1*
%{_mandir}/man5/ctdb*.5*
%{_mandir}/man7/ctdb*.7*

%files -n ctdb-tests
%doc ctdb/tests/README


%endif # with_clustering_support


%changelog
* Mon Aug 15 2022 tex - 4.16.4-1pclos2022
- new version

* Mon Dec 02 2019 tex - 4.10.8-2pclos2019
- rebuild against updates

* Tue Sep 03 2019 tex - 4.10.8-1pclos2019
- new version

